package kochController;

import kochView.*;
import kochModel.*;

import java.awt.*;

/**
 * @dependency kochView.IControlAdapter instantiates
 * @dependency kochView.IPaintAdapter instantiates
 * @dependency kochModel.KochModel instantiates
 * @dependency kochView.KochFrame instantiates
 */
public class KochController
{

    public void makeKoch(int closeOp ) {
        final KochModel model = new KochModel();

        KochFrame view = new KochFrame(new IPaintAdapter() {
              public void paint(Graphics g) {
                model.paint(g);
              }
            },
            new IControlAdapter() {
              public int reset() {
                model.reset();
                return model.count();
              }
              public int grow() {
                model.grow();
                return model.count();
              }
              public void changeFactoryTo(String s) {
                model.changeFactoryTo(s);
              }
              public void changePaintAlgoTo(String s) {
                model.changePaintAlgoTo(s);
              }

            },
            closeOp
          );

      view.setVisible(true);

    }

}